#include <Servo.h>// I use the Servo.h library to control servo motors.
// There's no need to install this library; it comes pre-installed in the Arduino programming environment.
#define trigPin 7 // the TRIG pin of the distance sensor is connected to D7
#define echoPin 6 // the ECHO pin of the distance sensor is connected to D6
Servo lid; // we refer to the servo motor as 'lid'

void setup(){
  pinMode(trigPin, OUTPUT);// pin 7 is for sending information
  pinMode(echoPin, INPUT);// pin 6 is for receiving information
  lid.attach(9); // connect the servo motor to D9
}

void loop(){
  long duration, distance; // declare two variables to store time (duration) and distance
  digitalWrite(trigPin, LOW);// to start, make sure it's not sending an ultrasonic pulse
  delayMicroseconds(2);// wait for 2 microseconds to avoid interference
  digitalWrite(trigPin, HIGH);// send a pulse
  delayMicroseconds(10);// the pulse lasts for 10 microseconds
  digitalWrite(trigPin, LOW);// stop the pulse
  duration = pulseIn(echoPin, HIGH);// listen for the echo of the pulse to determine the duration
  distance = (duration/2) / 29.1;
  // The speed of sound is 340 meters per second, or equivalently, one centimeter every 29.1 microseconds.
  // The ping travels from the sensor, bounces off the hand, and returns to the sensor. 
  // The distance it covers is twice the actual distance. Therefore, "duration" needs to be divided by 2, 
  // and the distance is the time divided by two and then divided by 29.1.

  if (distance < 10){// if the distance is less than 10 cm
    lid.write(90);// set the servo motor to ninety degrees (open mouth)
    delay(100);// wait for 100 milliseconds, i.e., 1/10 of a second
    lid.write(40);// set the servo motor to forty degrees (semi-open mouth)
    delay(100);// wait for 100 milliseconds, i.e., 1/10 of a second
    lid.write(90);// set the servo motor to ninety degrees (open mouth)
    delay(100);// wait for 100 milliseconds, i.e., 1/10 of a second
    lid.write(40);// set the servo motor to forty degrees (semi-open mouth)
    delay(100);// wait for 100 milliseconds, i.e., 1/10 of a second
    lid.write(90);// set the servo motor to ninety degrees (open mouth)
    delay(100);// wait for 100 milliseconds, i.e., 1/10 of a second
    lid.write(0);// set the servo motor to zero degrees (closed mouth)
  }
  else{ // if not,
    lid.write(0);// leave the servo motor at zero degrees (closed mouth)
  }
  delay(500);// wait for half a second before sending another pulse
}

